// trying to duplicate the result shown on https://datagenetics.com/blog/july12019/index.html
// failing so far...

// had to extend fp14 from 2.14 to 18.14 to fit larger numbers.  Using long long to hold 18.14*18.14 intermediates.

#include <stdio.h>
#include <stdlib.h>

typedef long long fp14;

#define int2fp(x) ((x) << 14LL)
#define fp2int(x) ((x) >> 14LL)

const fp14 qsine[65] = {
     0,    402,    803,   1205,   1605,   2005,   2404,   2801, 
  3196,   3589,   3980,   4369,   4756,   5139,   5519,   5896, 
  6269,   6639,   7005,   7366,   7723,   8075,   8423,   8765, 
  9102,   9434,   9759,  10079,  10393,  10701,  11002,  11297, 
 11585,  11866,  12139,  12406,  12665,  12916,  13159,  13395, 
 13622,  13842,  14053,  14255,  14449,  14634,  14810,  14978, 
 15136,  15286,  15426,  15557,  15678,  15790,  15892,  15985, 
 16069,  16142,  16206,  16260,  16305,  16339,  16364,  16379, 
 16384,
};

static inline fp14 hsine(unsigned char x) {
  return x>=64 ? qsine[128-x] : qsine[x];
}

static inline fp14 sine(unsigned char x) {
  return x&0x80 ? -hsine(x&0x7f) : hsine(x);
}

#define fpSin(x) (sine((x) & 0xff))
#define fpCos(x) (sine(((x)+64) & 0xff))

fp14 pi_fp;
fp14 pi_squared_fp;
fp14 pi_sq_times_5_fp;

fp14 bhaskara(int x_angle256) {
  fp14 pi_minus_x_fp;
  fp14 x_radians_fp;
  fp14 numer_fp, denom_fp, times4_fp, result_fp;
  
  x_radians_fp = (pi_fp*x_angle256)>>8; // Convert to radians. 256 angles in a circle. circle = pi radians
  fprintf(stdout, "x_fp: %lld\n", x_radians_fp);

  pi_minus_x_fp = pi_fp - x_radians_fp;
  fprintf(stdout, "pi_minus_x_fp %lld\n", pi_minus_x_fp);

  numer_fp = pi_minus_x_fp<<4;
  fprintf(stdout, "numer: %lld\n", numer_fp);

  times4_fp = pi_minus_x_fp<<2;
  fprintf(stdout, "times4: %lld\n", times4_fp);

  denom_fp = pi_sq_times_5_fp - times4_fp;
  fprintf(stdout, "denom: %lld\n", denom_fp);

  result_fp = int2fp(numer_fp) / denom_fp;
  return result_fp;
}

int main(int argc, char **argv) {
  int angle;
  pi_fp = int2fp(31416)/10000; // can be stored as a constanr
  fprintf(stdout, "pi: %lld\n", pi_fp);
  pi_squared_fp = fp2int(pi_fp * pi_fp); // also a constant
  fprintf(stdout, "pi^2: %lld\n",  pi_squared_fp);
  pi_sq_times_5_fp = pi_squared_fp * 5; // another constant
  fprintf(stdout, "5*pi^2: %lld\n", pi_sq_times_5_fp);
  for (angle = 0; angle < 64; angle += 1) {
    fprintf(stdout, "%d: table: %lld calc: %lld\n", angle, fpSin(angle), bhaskara(angle));
  }
}
