#include <stdio.h>
#include <stdlib.h>

// This generates the foreground and background mountain range profiles.  Works OK-ish.

int randrange(int low, int high) { // inclusive
  int max = high-low+1;
  int r=random()&0x7f;
  return low+(r%max);
}

int main(int argc, char **argv) {
  int forex[1024], forey[1024],
      backx[1024], backy[1024];
  int x, i, width;
  int MountainHeight, MountainWidthLeft, MountainWidthRight, GapWidth, BackPeakX;

  // Mountain height 0:15
  // Mountain width from peak 30 to 60 (2 to 4 x units)
  // gaps between foothills  15:30 (1 to 2 x units)
  // Background mountains have peaks in the gaps
  // width from peak to edge 15 to 30 (1 to 2 x units)
  // Algorithm is to have an edge-to-edge single line (foreground mountains)
  // and then add the background mountains, clipping to that line.

  // forex[n] contains 0:15 and represents the x offset of the only peak within that x segment
  // forey[n] is the height of that peak.

  // special case for volcano:
  
  for (i = 0; i < 1024; i++) forex[i] = 0; // 3+randrange(0,9);
  for (i = 0; i < 1024; i++) backx[i] = 0; // 3+randrange(0,9);

  x = 10;
  for (;;) { // each x unit is 15
    // place a mountain at current x.

    MountainHeight = 15-randrange(0,4);
    //for (i = 0; i < MountainHeight-10; i++) fprintf(stdout, "@@@");fprintf(stdout, "\n");
    MountainWidthLeft = randrange(3,5); 
    MountainWidthRight = randrange(3,5); // first is peak
    if (x+MountainWidthLeft+MountainWidthRight >= 1024) {
      // too close to end.  Fill with 0's
      for (;;) {
	if (x == 1024) break;
	forey[x] = 0;
	x += 1;
      }
      break;
    }
    for (width = 0; width <= MountainWidthLeft-1; width++) {
      forey[x++] = MountainHeight*width/(MountainWidthLeft);
    }
    forey[x++] = MountainHeight;
    for (width = MountainWidthRight-1; width >= 0; width--) {
      forey[x++] = MountainHeight*width/(MountainWidthRight);
    }

    // Follow  mountains by gaps, and mark bg for center of new mountain
    if (x >= 1024-5) {
      GapWidth = 1024-x;
    } else {
      GapWidth = randrange(0,1);
      // Place bacground peak in gap.
      BackPeakX = x+GapWidth/2+randrange(0,1);
      backy[BackPeakX]=16;
    }
    for (i = 0; i < GapWidth; i++) {
      forey[x++] = 0;
    }
    if (x == 1024) break;
  }


  // --- place bg
  x = 0;
  for (;;) { // each x unit is 15
    // place a mountain.
    MountainHeight = 13-randrange(0,4);
    //for (i = 0; i < MountainHeight-10; i++) fprintf(stdout, "@@@");fprintf(stdout, "\n");
    MountainWidthLeft = randrange(3,5); 
    MountainWidthRight = randrange(3,5); // first is peak

    if (backy[x]==16) {
      backy[x] = 0;
      x -= MountainWidthLeft;
      for (width = 0; width <= MountainWidthLeft-1; width++) {
        backy[x++] = MountainHeight*width/(MountainWidthLeft);
      }
      backy[x++] = MountainHeight;
      for (width = MountainWidthRight-1; width >= 0; width--) {
        backy[x++] = MountainHeight*width/(MountainWidthRight);
      }
    }
    x += 1;
    if (x == 1024) break;
  }


  
  forex[1021] = 0; forey[1021] = 0;
  forex[1022] = 0; forey[1022] = 0;
  forex[1023] = 0; forey[1023] = 0;
  forex[0] = 0; forey[0] = 0; // VOLCANO
  forex[1] = 0; forey[1] = 0;
  forex[2] = 0; forey[2] = 0;
  forex[3] = 0; forey[3] = 0;

  backx[1021] = 0; backy[1021] = 0;
  backx[1022] = 0; backy[1022] = 0;
  backx[1023] = 0; backy[1023] = 0;
  backx[0] = 0; backy[0] = 0; // VOLCANO
  backx[1] = 0; backy[1] = 0;
  backx[2] = 0; backy[2] = 0;
  backx[3] = 0; backy[3] = 0;
  //-------------------------------------------------------------------------- fg
  for (i = 0; i < 1024; i++) {
    fprintf(stdout, "  // ");
    for (x = 0; x < 16; x++) {
      if (x < forey[i]) fprintf(stdout, "@");
    }
    fprintf(stdout, "\n");
  }

  //-------------------------------------------------------------------------- bg
  for (i = 0; i < 1024; i++) {
    fprintf(stdout, "  // ");
    for (x = 0; x < 16; x++) {
      if (x < backy[i]) fprintf(stdout, "#");
    }
    fprintf(stdout, "\n");
  }
  //-------------------------------------------------------------------------- array
  for (i = 0; i < 1024; i++) {
    fprintf(stdout, "  %d,%d<<2, %d,%d<<2,  %d,%d<<2, %d,%d<<2,\n\n",
            forex[i],forey[i],
	    forex[(i+1)&1023],forey[(i+1)&1023],
            backx[i],backy[i],
	    backx[(i+1)&1023],backy[(i+1)&1023]
	    );
  }
}
