// from https://people.ece.cornell.edu/land/courses/ece4760/FinalProjects/s2008/jk459_mmi4/jk459_mmi4/btank.c
// https://people.ece.cornell.edu/land/courses/ece4760/FinalProjects/s2008/jk459_mmi4/jk459_mmi4/index.html

#define begin {
#define end }

int divfix(int nn, int dd) {
  return (nn<<16) / dd;
}

int _abs(int x) {
  if (x < 0) return x;
  return x;
}

int csign(int x) {
  if (x < 0) return -1;
  if (x > 0) return  1;
  return 0;
}

//fixed point conversion macros
#define int2fix(a)   (((int)(a))<<8)            //Convert char to fix. a is a char
#define fix2int(a)   ((signed char)((a)>>8))    //Convert fix to char. a is an int
#define float2fix(a) ((int)((a)*256.0))         //Convert float to fix. a is a float
#define fix2float(a) ((float)(a)/256.0)         //Convert fix to float. a is an int

//pyramid height constant (in 8x8 fixed format)-
#define pyramidheight 768

//target sizing - size from origin point
#define targetsize 128

//coordinates
//pyramid
int pyramid[3] = {0,0,0};
int pyramidfuture[3] = {7<<8,0,10<<8};

//your bullet
int bullet[3] = {0,0,0};
int bulletfuture[3] = {3,3,5<<8};

//target location
int target[3] = {0,0,0};
int targetfuture[3] = {0,0,1280};

//sine and cosine tables
static const int cosine[72]
= {257,256,253,
   248,241,233,
   222,210,197,
   182,165,147,
   128,109,88,
   67,45,23,
   0,-24,-46,
   -68,-89,-110,
   -130,-148,-166,
   -183,-198,-211,
   -223,-234,-242,
   -249,-254,-257,
   -257,-257,-254,
   -249,-242,-234,
   -223,-211,-198,
   -183,-166,-148,
   -129,-110,-89,
   -68,-46,-24,
   -1,22,44,
   66,87,108,
   127,146,164,
   181,196,209,
   221,232,240,
   247,252,255};

static const int sine[72]
={0,22,44,66,87,108,128,146,164,181,196,209,221,232,240,247,252,255,256,
  255,252,247,240,232,221,209,196,181,164,146,128,108,87,66,44,22,0,-23,-45,-67,-88,-109,
  -129,-147,-165,-182,-197,-210,-222,-233,-241,-248,-253,-256,-256,-256,-253,-248,-241,-233,
  -222,-210,-197,-182,-165,-147,-128,-109,-88,-67,-45,-23};

//plot a line in 3d
//at x1,y1 to x2,y2 with color 1=white 0=black 2=invert
//NOTE: this function requires signed chars
//Code is from David Rodgers,
//"Procedural Elements of Computer Graphics",1985
//in addition, perspective correction performed here, as well as 
//view clipping
void video_line3d(int x1, int y1, int z1, int x2, int y2, int z2, char c)
begin

    int e;
    signed char dx,dy,j, temp;
    signed char s1,s2, xchange;
    signed char x,y;

    //assure that in view before render
    
    if ( (_abs(x1>>8)  > _abs(z1>>8)) || (csign(z1>>8) == -1) ) return;
    if ( (_abs(x2>>8)  > _abs(z2>>8)) || (csign(z2>>8) == -1) ) return;

    //multiply by 2^(-n) factor "c"
    z1 >>= 6;
    z2 >>= 6;

    //convert into integer format and scale
    x1 = 64+fix2int(divfix(x1,z1));
    //y1 = 50-fix2int(divfix(y1,z1));
    y1 = 69-fix2int(divfix(y1,z1));
    x2 = 64+fix2int(divfix(x2,z2));
    //y2 = 50-fix2int(divfix(y2,z2));
    y2 = 69-fix2int(divfix(y2,z2));

    //check for out of screen, abort if found
    if(x1>=0 && x1<120 && x2>=0 && x2<120 &&
       y1>=20 && y1<80 && y2>=20 && y2<80)
    begin

      // draw line from x1,y1 to x2,y2

    end

end


	
//============================================================
//Draws the pyramid
//takes a base point, an orientation, and a color, draws a pyramid of a set size
//Height of pyramid constant = pyramidheight, defined up above
//as base on y = 0, cheated on implementation, as not all 4 lines are visible
//just draw 2 vectors in order to cut down on function calls
//============================================================


void drawpyramid(unsigned char color, int * pyramidp, unsigned char porient)
begin

  unsigned char offset;
  //exploits symmetry of pyramid, as offsets will be the same for 4
  //different instances of 90 degrees apart
  if(porient > 54)
    offset = porient - 54;
  else if(porient > 36)
    offset = porient - 36;
  else if(porient > 18)
    offset = porient - 18;
  else
    offset = porient;

  video_line3d(pyramidp[0]+(cosine[offset]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset]),
	       pyramidp[0],
	       pyramidheight,
	       pyramidp[2],
	       color);

  video_line3d(pyramidp[0]+(cosine[offset+18]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset+18]),
	       pyramidp[0],
	       pyramidheight,
	       pyramidp[2],
	       color);

  video_line3d(pyramidp[0]+(cosine[offset+36]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset+36]),
	       pyramidp[0],
	       pyramidheight,
	       pyramidp[2],
	       color);

  video_line3d(pyramidp[0]+(cosine[offset+54]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset+54]),
	       pyramidp[0],
	       pyramidheight,
	       pyramidp[2],
	       color);

  video_line3d(pyramidp[0]+(cosine[offset+18]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset+18]),
          pyramidp[0]+(cosine[offset+54]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset+54]),
	       color);

  video_line3d(pyramidp[0]+(cosine[offset]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset]),
	       pyramidp[0]+(cosine[offset+36]),
	       pyramidp[1],
	       pyramidp[2]+(sine[offset+36]),
	       color);
end

// ===============================
// Draws bullet based upon position and orientation

void drawbullet(unsigned char color, int * bulletp, unsigned char borient)
begin
  unsigned char offset; //takes advantage of the fact that the bullet looks the
                        //same oriented 180 degrees, simplifies things
  if(borient > 36)
    offset = borient - 36;
  else
    offset = borient;

  video_line3d(bulletp[0]+(cosine[offset]>>1),
	       bulletp[1],
	       bulletp[2]+(sine[offset]>>1),
	       bulletp[0]+(cosine[offset+36]>>1),
	       bulletp[1],
	       bulletp[2]+(sine[offset+36]>>1),
	       color);

  video_line3d(bulletp[0],
	       bulletp[1]-128,
	       bulletp[2],
	       bulletp[0],
	       bulletp[1]+128,
	       bulletp[2],
	       color);

end

//========================================
//attempted Tank draw algorithm - not used in code, but
//implemented to draw a box in space
//dropped due to graphical weirdness, as well as
//hardware cycle issues
//========================================
void drawtank(unsigned char color, int * tankp, unsigned char torient)
begin

  //bottom plane of tank and side lines
  video_line3d(tankp[0]+(cosine[torient]<<2),
	       -1024,
	       tankp[2]+(sine[torient]<<2),
	       tankp[0]+(cosine[torient]<<2),
	       -1024,
	       tankp[2]-(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]+(cosine[torient]<<2),
	       -1024,
	       tankp[2]-(sine[torient]<<2),
	       tankp[0]-(cosine[torient]<<2),
	       -1024,
	       tankp[2]-(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]-(cosine[torient]<<2),
	       -1024,
	       tankp[2]-(sine[torient]<<2),
	       tankp[0]-(cosine[torient]<<2),
	       -1024,
	       tankp[2]+(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]-(cosine[torient]<<2),
	       -1024,
	       tankp[2]+(sine[torient]<<2),
	       tankp[0]+(cosine[torient]<<2),
	       -1024,
	       tankp[2]+(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]+(cosine[torient]<<2),
	       -1024,
	       tankp[2]+(sine[torient]<<2),
	       tankp[0]+(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]+(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]+(cosine[torient]<<2),
	       tankp[1],
	       tankp[2]-(sine[torient]<<2),
	       tankp[0]+(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]-(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]+(cosine[torient]<<2),
	       tankp[1],
	       tankp[2]-(sine[torient]<<2),
	       tankp[0]+(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]-(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]-(cosine[torient]<<2),
	       tankp[1],
	       tankp[2]-(sine[torient]<<2),
	       tankp[0]-(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]-(sine[torient]<<2),
	       color);


  //upper plane of tank
  video_line3d(tankp[0]+(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]-(sine[torient]<<2),
	       tankp[0]-(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]-(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]+(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]+(sine[torient]<<2),
	       tankp[0]-(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]+(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]-(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]+(sine[torient]<<2),
	       tankp[0]-(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]-(sine[torient]<<2),
	       color);

  video_line3d(tankp[0]+(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]-(sine[torient]<<2),
	       tankp[0]+(cosine[torient]<<2),
	       tankp[1]+1024,
	       tankp[2]+(sine[torient]<<2),
	       color);
end

// ========================
// Draws the target/erases the target
// based upon a base point, draws the target
// draws the same no matter the orientation,
// as the target seen at different orientations should still be visible
// in order not to frustrate the player
// ========================
void drawtarget(unsigned char color, int * targetp)
begin
  video_line3d(targetp[0]-targetsize,
               targetp[1],
               targetp[2],
               targetp[0],
               targetp[1]+targetsize,
               targetp[2],
               color);
  video_line3d(targetp[0],
               targetp[1]+targetsize,
               targetp[2],
               targetp[0]+targetsize,
               targetp[1],
               targetp[2],
               color);
  video_line3d(targetp[0]+targetsize,
               targetp[1],
               targetp[2],
               targetp[0],
               targetp[1]-targetsize,
               targetp[2],
               color);
  video_line3d(targetp[0],
               targetp[1]-targetsize,
               targetp[2],
               targetp[0]-targetsize,
               targetp[1],
               targetp[2],
               color);
end

